'Turn error checking on or off:
On Error Resume Next

'Set needed objects:

Const SaveLog = 0

set wshell = CreateObject("WScript.Shell")
Set objShell = CreateObject("WScript.Shell")
Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objFSOLog = CreateObject("Scripting.FileSystemObject")
set objNetwork = WScript.CreateObject("WScript.Network")
Set WSHShell = CreateObject("Wscript.Shell")
Set objSh = CreateObject("Shell.Application")

Const ForReading = 1
Const ForWriting = 2
Set custError = 0




'Get current directory:
'strcurrentDirectory = left(WScript.ScriptFullName,(Len(WScript.ScriptFullName))-(len(WScript.ScriptName)))

'Set working directory to user's temp folder:
'strcurrentDirectory = WScript.CreateObject("Scripting.FileSystemObject").GetSpecialFolder(2)

' Updated to use their Documents folder as the temp folder no longer worked consistently TH 8/14/2017
strcurrentDirectory = wshell.ExpandEnvironmentStrings("%UserProfile%")+"\Documents\"


Set objLogFile = objFSOLog.CreateTextFile("" & strcurrentDirectory & "WUSTLPrintLog.txt")
objLogFile.Close

Set objLogFile = objFSOLog.OpenTextFile("" & strcurrentDirectory & "WUSTLPrintLog.txt", ForWriting)



objLogFile.WriteLine "current directory: " & strcurrentDirectory


'Give welcome message to users:
WScript.Echo "This script will setup your computer to print at Washington University in St. Louis." & vbCr & vbCr & "Please note that some ""Home"" editions of Windows are not compatible with network printers and will not function properly."

'Prompt for WUSTL key username and password:

sUserName = InputBox("Please enter your WUSTL KEY username:","Username Prompt") 
sPassword = InputBox("Please enter your WUSTL KEY password:", "Password Prompt") 

objLogFile.WriteLine "sUserName: " & sUserName
objLogFile.WriteLine "sPassword: xxxxxxxx" 


WScript.echo "Please be patient as setup continues. This window will close and the script will take 2-3 minutes to run silently in the background." & vbCr & vbCr & "As the script is running, you may be asked to allow the installation of print drivers. You must click ""Allow"" in order for the setup to finish."

objLogFile.WriteLine "Before creating AddWinCred.ps1"

'Create AddWinCred.ps1 powershell script and add needed lines:

Set objFile = objFSO.CreateTextFile("" & strcurrentDirectory & "AddWinCred.ps1")
objFile.Close

objLogFile.WriteLine "After creating AddWinCred.ps1 but before adding code."


Set objFile = objFSO.OpenTextFile("" & strcurrentDirectory & "AddWinCred.ps1", ForWriting)
objFile.WriteLine "$sig = @"""
objFile.WriteLine "[DllImport(""Advapi32.dll"", SetLastError=true, EntryPoint=""CredWriteW"", CharSet=CharSet.Unicode)]"
objFile.WriteLine "public static extern bool CredWrite([In] ref Credential userCredential, [In] UInt32 flags);"
objFile.WriteLine "[StructLayout(LayoutKind.Sequential, CharSet=CharSet.Unicode)]"
objFile.WriteLine "public struct Credential"
objFile.WriteLine "{"
objFile.WriteLine "   public UInt32 flags;"
objFile.WriteLine "   public UInt32 type;"
objFile.WriteLine "   public IntPtr targetName;"
objFile.WriteLine "   public IntPtr comment;"
objFile.WriteLine "   public System.Runtime.InteropServices.ComTypes.FILETIME lastWritten;"
objFile.WriteLine "   public UInt32 credentialBlobSize;"
objFile.WriteLine "   public IntPtr credentialBlob;"
objFile.WriteLine "   public UInt32 persist;"
objFile.WriteLine "   public UInt32 attributeCount;"
objFile.WriteLine "   public IntPtr Attributes;"
objFile.WriteLine "   public IntPtr targetAlias;"
objFile.WriteLine "   public IntPtr userName;"
objFile.WriteLine "}"
objFile.WriteLine """@"
objFile.WriteLine "Add-Type -MemberDefinition $sig -Namespace ""ADVAPI32"" -Name 'Util'"
objFile.WriteLine "'Powershell Script Running.' >>'"& strcurrentDirectory & "PowerShellLog.txt'"
objFile.WriteLine "$cred = New-Object ADVAPI32.Util+Credential"
objFile.WriteLine "$cred.flags = 0"
objFile.WriteLine "$cred.type = 2"
objFile.WriteLine "$cred.targetName = [System.Runtime.InteropServices.Marshal]::StringToCoTaskMemUni('stsops.rts.wustl.edu')"
objFile.WriteLine "$cred.userName = [System.Runtime.InteropServices.Marshal]::StringToCoTaskMemUni('accounts.ad.wustl.edu\" & sUserName & "')"
objFile.WriteLine "$cred.attributeCount = 0"
objFile.WriteLine "$cred.persist = 2"
objFile.WriteLine "$password = """ & sPassword & """"
objFile.WriteLine "$cred.credentialBlobSize = [System.Text.Encoding]::Unicode.GetBytes($password).length"
objFile.WriteLine "$cred.credentialBlob = [System.Runtime.InteropServices.Marshal]::StringToCoTaskMemUni($password)"
objFile.WriteLine "try"
objFile.WriteLine "{"
'objFile.WriteLine "$divisor = 0"   'this line and the following simply throw an exception
'objFile.WriteLIne "[int]$a = 1/$divisor"
objFile.WriteLine "[ADVAPI32.Util]::CredWrite([ref]$cred,0)"
objFile.WriteLine "'No error thrown adding credential' >>'"& strcurrentDirectory & "PowerShellLog.txt'"
objFile.WriteLine "}"
objFile.WriteLine "catch [Exception]"
objFile.WriteLine "{"
objFile.WriteLine "$Error[0] >>'"& strcurrentDirectory & "PowerShellLog.txt'"
objFile.WriteLine "}"
objFile.WriteLIne"finally {"
objFile.WriteLine "'Done with Powershell code.' >>'"& strcurrentDirectory & "PowerShellLog.txt'"
objFile.WriteLIne "}"
wscript.sleep (1000)
objFile.Close
wscript.sleep (3000)


objLogFile.WriteLine "After adding code to AddWinCred.ps1"

'Create runps1script.bat file and add needed lines:

Set objFile = objFSO.CreateTextFile("" & strcurrentDirectory & "runps1script.bat")
objFile.Close
Set objFile = objFSO.OpenTextFile("" & strcurrentDirectory & "runps1script.bat", ForWriting)
objFile.WriteLine "Please wait while the print setup is configured..."
objFile.WriteLine "powershell.exe Set-ExecutionPolicy Unrestricted"
objFile.WriteLine "ping -n 5 127.0.0.1 > nul"
objFile.WriteLine "powershell.exe" & " " & strcurrentDirectory & "AddWinCred.ps1"
objFile.WriteLine "ping -n 5 127.0.0.1 > nul"
objFile.WriteLine "powershell.exe Set-ExecutionPolicy RemoteSigned"
wscript.sleep (1000)
objFile.Close
wscript.sleep (3000)




'Run AddWinCred.ps1:
objLogFile.WriteLine "Run AddWinCred.ps1"

objSh.ShellExecute "" & strcurrentDirectory & "runps1script.bat", "" , "", "runas", 0
'WSHShell.Run ("" & strcurrentDirectory & "runps1script.bat") 
WScript.sleep (10000)


'Add WUSTLprint queue:
objLogFile.WriteLine "Add WUSTLprint queue"

objNetwork.AddWindowsPrinterConnection "\\stsops.rts.wustl.edu\WUSTLprint"
If Err.Number <> 0 Then
    objLogFile.WriteLine "Error Adding WUSTLprint : " & Err.Number 
    custError = Err.Number
    Err.Clear
End If
WScript.sleep (5000)

'Add WUSTLprint-Color queue:
objLogFile.WriteLine "Add WUSTLprint-Color queue"

objNetwork.AddWindowsPrinterConnection "\\stsops.rts.wustl.edu\WUSTLprint-Color"
If Err.Number <> 0 Then
    objLogFile.WriteLine "Error Adding WUSTLprint-Color: " & Err.Number
    custError = Err.Number
    Err.Clear
End If
WScript.sleep (5000)


'Set WUSTLPrint to be default printer:
objLogFile.WriteLine "Set WUSTLPrint to be default printer"

objNetwork.SetDefaultPrinter "\\stsops.rts.wustl.edu\WUSTLprint"


'Delete processing files:
objLogFile.WriteLine "Delete processing files"


Dim fso
Set fso = CreateObject("Scripting.FileSystemObject")
fso.DeleteFile "" & strcurrentDirectory & "AddWinCred.ps1", True
fso.DeleteFile "" & strcurrentDirectory & "runps1script.bat", True

'Wait for files to delete
'wscript.sleep 2000

If SaveLog <> 1 Then
     objLogFile.close
     set objLogFile = Nothing
     fso.DeleteFile "" & strcurrentDirectory & "WUSTLPrintLog.txt", True
     fso.DeleteFile "" & strcurrentDirectory & "PowerShellLog.txt", True
End If



'End and quit the script
If custError = O Or custError = 424 Then
    WScript.Echo "You are now setup to print to Washington University campus printers. Use the WUSTLprint queue for grayscale printing, and WUSTLPrint-Color for color printing."
Else
    WScript.Echo "An error occured. Please contact STS."
End If